using ViewComponents.Exeption;

namespace TestView
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void buttonAdd_Click(object sender, EventArgs e)
		{

			list_with_choice.Fill_List("");
			list_with_choice.Fill_List("");
			list_with_choice.Fill_List("");
			list_with_choice.Fill_List("");
		}

		private void buttonClear_Click(object sender, EventArgs e)
		{
			list_with_choice.Clean_List();
		}

		private void buttonSelect_Click(object sender, EventArgs e)
		{
			MessageBox.Show(list_with_choice.Element ?? "null", " ");
		}

		private void list_with_choice_SelectedItemChange(string obj)
		{
			MessageBox.Show(obj, "  ");
		}

		private void buttonDip_Click(object sender, EventArgs e)
		{
			input_text.MinLen = 5;
			input_text.MaxLen = 25;

			MessageBox.Show($"Min: {input_text.MinLen}; Max: {input_text.MaxLen}");
		}

		private void buttonVal_Click(object sender, EventArgs e)
		{
			input_text.Element = "Sample text";
		}

		private void input_text_ItemChange(string obj)
		{
			MessageBox.Show(obj, "  ");
		}

		private void buttonCheck_Click(object sender, EventArgs e)
		{
			try
			{
				if (input_text.Element.Equals("Range exeption"))
					throw new TextBoundsNotSetExeption("  ");
				if (input_text.Element.Equals("Value exeption"))
					throw new TextOutOfBoundsExeption("  ");
				
				MessageBox.Show(input_text.Element, " ");
			}
			catch (TextBoundsNotSetExeption ex)
			{
				MessageBox.Show(ex.Message);
			}
			catch (TextOutOfBoundsExeption ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void buttonIerarhy_Click(object sender, EventArgs e)
		{
			myTreeView.setHierarchy(new List<(string, bool)> { ("Genre", false), ("Author", false), ("Title", true) });
			MessageBox.Show(" ");
		}

		private void buttonAddBook_Click(object sender, EventArgs e)
		{
			
			myTreeView.addItem(new Book("", " ..", "̸ "));
			myTreeView.addItem(new Book("", " ..", "  "));
			myTreeView.addItem(new Book("", " ", "1984"));
			myTreeView.addItem(new Book("", "", " "));
		}

		private void buttonGetValue_Click(object sender, EventArgs e)
		{
			Book? book = myTreeView.getSelecetedNodeValue<Book>();
			if (book == null) return;
			MessageBox.Show(": " + book.Genre + ", : " + book.Author + ", : " + book.Title);
		}

		private void buttonGetIndex_Click(object sender, EventArgs e)
		{
			MessageBox.Show(myTreeView.SelectedNodeIndex.ToString());
		}

		private void buttonSetIndex_Click(object sender, EventArgs e)
		{
			myTreeView.SelectedNodeIndex = 1;
		}

		private void Form1_Load(object sender, EventArgs e)
		{

		}
	}
}